function [VBLTimestamp1,VBLTimestamp2,refreshr,w1,w2,ifi]=PsychSetupProtocol(Refreshr,Trialduration,Okrspeed,C,Ncycl,single,triple,projector)

  Screen('Preference', 'VisualDebugLevel', 1);
  load('PsychSetup.mat')

  for j=1:length(Trialduration)
     
    refreshr=Refreshr(j);
    trialduration=Trialduration(j);
    okrspeed=Okrspeed(j);
    c=C(j);
    ncycl=Ncycl(j);
    singledisplay = single;
    tripledisplay = triple;
    
    try
      nframes = round(FrameRate(singledisplay)/refreshr);
    catch
      nframes = round(60/refreshr);
    end

    %071015 create name for saving stimulus
    basename='Stim';
    st_ncycl=num2str(ncycl);
    st_v=num2str(okrspeed);
    st_c=num2str(c);
    st_refreshr=num2str(refreshr);

    try
      mkdir('Stimuli');
    catch
    end
    fullname=['Stimuli/' basename '_c_' st_c '_v_' st_v '_ncycl_' st_ncycl  '_refreshr_' st_refreshr '.mat'];

    try

%       Screen('BlendFunction', w1, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); %enable alpha blending (transparency)
%       Screen('BlendFunction', w2, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); %enable alpha blending (transparency)
      
      try
        ifi = Screen('GetFlipInterval',w1,200);
      catch
        ifi=1/60;
      end
      
      white=WhiteIndex(singledisplay);
      black=BlackIndex(singledisplay);
      gray=(white+black)/2;
      fog1 = Screen(w1, 'MakeTexture', gray);
      fog2 = Screen(w2, 'MakeTexture', gray);

      if okrspeed~=0
        frpcyc=(round(1/abs(okrspeed)*360/ncycl*nframes));% frames for one cycle
      else
        frpcyc=1;
      end

      try
        load (fullname);
      catch
      end

      clear gratingalpha1 gratingalpha2;
      for i=1:frpcyc        

        if projector==10000 % i.e., skip for now
            
            % Add code here! XXX
            
        else
            
          grating1=sin(ncycl*horizontang1(1,:)+i*sign(okrspeed)/frpcyc*2*pi);
          grating1=gray+c.*(gray).*grating1; % contrast c
          grating1= 255*((grating1/255).^(1/2));
          grating1=255-grating1;
          for k=1:3
            gratingalpha1(1,:,k,i)=grating1;
          end
          gratingalpha1(1,:,4,i)=255;
          centerleft1(i)=Screen('MakeTexture',w1, gratingalpha1(:,:,:,i)); %#ok<NASGU>
  
          grating2=sin(ncycl*horizontang2(1,:)+i*sign(okrspeed)/frpcyc*2*pi);
          grating2=gray+c.*(gray).*grating2; % contrast c
          grating2= 255*((grating2/255).^(1/2));
          grating2=255-grating2;
          for k=1:3
            gratingalpha2(1,:,k,i)=grating2;
          end
          gratingalpha2(1,:,4,i)=255;
          centerleft2(i)=Screen('MakeTexture',w2, gratingalpha2(:,:,:,i));  %#ok<NASGU>
 
        end
        
      end
      
      save(fullname, 'gratingalpha1','gratingalpha2');

%       %070726 calculate vertical alpha mask:
%       maxangle=atan2(height/2,rad2);
%       vertalpha=(abs(vertang)>maxangle).*255+(abs(vertang)<=maxangle).*0;
%       vertmask(:,:,4)=vertalpha;
%       for i=1:3
%         vertmask(:,:,i)=0;
%       end
      verttext1 = Screen('MakeTexture',w1,vertmask1);
      
%       maxangle2=atan2(height2/2,rad2_2);
%       vertalpha2=(abs(vertang2)>maxangle2).*255+(abs(vertang2)<=maxangle2).*0;
%       vertmask2(:,:,4)=vertalpha2;
%       for i=1:3
%         vertmask2(:,:,i)=0;
%       end
      verttext2 = Screen('MakeTexture',w2,vertmask2);

      s=GetSecs;         
      now=GetSecs-s;        
      while now<=1 %Interval between stimuli
          
        if projector
            
          Screen('DrawTexture', w1, fog1, lineRect1, Screen1rect);
          Screen('DrawTexture', w1, verttext1,[],Screen1rect);
          Screen('DrawTexture', w2, fog2,lineRect2,Screen2rect);
          Screen('DrawTexture', w2, verttext2,[],Screen2rect);
          
        else
            
          Screen('DrawTexture', w1, fog1, lineRect1, Screen1rectd1);
          Screen('DrawTexture', w1, verttext1,[],Screen1rectd1); 
          Screen('DrawTexture', w1, fog1, lineRect1, Screen1rectd2);
          Screen('DrawTexture', w1, verttext1,[],Screen1rectd2); 
          Screen('DrawTexture', w1, fog1, lineRect1, Screen1rectd3);
          Screen('DrawTexture', w1, verttext1,[],Screen1rectd3); 
          Screen('DrawTexture', w2, fog2,lineRect2,Screen2rect);
          Screen('DrawTexture', w2, verttext2,[],Screen2rect);
          
        end
      
        now=GetSecs-s;          
        Screen(w1,'Flip'); 
        Screen(w2,'Flip');
        
      end

      newname=['PsychPhase' [num2str(j)] '.mat'];
      
      if projector
        
        save(newname,'VBLTimestamp1','VBLTimestamp2','refreshr', ...
                     'trialduration','okrspeed','c', 'w1','w2', ...
                     'fog1','fog2','ifi','frpcyc','ncycl', ...
                     'centerleft1','centerleft2','verttext1','verttext2', ...
                     'ifi','lineRect1','lineRect2','Screen1rect', ...
                     'Screen2rect');
        
      else
        
        save(newname,'VBLTimestamp1','VBLTimestamp2','refreshr', ...
                     'trialduration','okrspeed','c', 'w1','w2', ...
                     'fog1','fog2','ifi','frpcyc','ncycl', ...
                     'centerleft1','centerleft2','verttext1','verttext2', ...
                     'ifi','lineRect1','lineRect2','Screen1rectd1', ...
                     'Screen1rectd2','Screen1rectd3','Screen2rect');
       
      end

      fileID = fopen('j.txt','w'); % Here, 'w' = permit write access.
      % save('j.mat','j_progr')
      j_progr=j;
      fprintf(fileID,[num2str(j_progr)]);
      fclose(fileID);
      
    catch
        
        %this "catch" section executes in case of an error in the "try" section
        %above.  Importantly, it closes the onScreen window if its open.
        Screen('CloseAll');
        ShowCursor;
        Priority(0);
        psychrethrow(psychlasterror);
        
    end

  end

% Screen('Preference', 'VisualDebugLevel', 1 );
% pause(5)
% clear all
% clear Screen

end
